const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class EpisDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const epis = await db.epis.create(
      {
        id: data.id || undefined,

        nome_epi: data.nome_epi || null,
        descricao: data.descricao || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await epis.setClientes(data.clientes || null, {
      transaction,
    });

    return epis;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const episData = data.map((item, index) => ({
      id: item.id || undefined,

      nome_epi: item.nome_epi || null,
      descricao: item.descricao || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const epis = await db.epis.bulkCreate(episData, { transaction });

    // For each item created, replace relation files

    return epis;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const epis = await db.epis.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.nome_epi !== undefined) updatePayload.nome_epi = data.nome_epi;

    if (data.descricao !== undefined) updatePayload.descricao = data.descricao;

    updatePayload.updatedById = currentUser.id;

    await epis.update(updatePayload, { transaction });

    if (data.clientes !== undefined) {
      await epis.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return epis;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const epis = await db.epis.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of epis) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of epis) {
        await record.destroy({ transaction });
      }
    });

    return epis;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const epis = await db.epis.findByPk(id, options);

    await epis.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await epis.destroy({
      transaction,
    });

    return epis;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const epis = await db.epis.findOne({ where }, { transaction });

    if (!epis) {
      return epis;
    }

    const output = epis.get({ plain: true });

    output.clientes = await epis.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.nome_epi) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('epis', 'nome_epi', filter.nome_epi),
        };
      }

      if (filter.descricao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('epis', 'descricao', filter.descricao),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.epis.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('epis', 'nome_epi', query),
        ],
      };
    }

    const records = await db.epis.findAll({
      attributes: ['id', 'nome_epi'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['nome_epi', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.nome_epi,
    }));
  }
};
